Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 3211)
@@ -44,5 +44,8 @@
    LOGICAL , PUBLIC, PARAMETER ::   lk_zdfkpp = .TRUE.    !: KPP vertical mixing flag
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghats    !: non-local scalar mixing term (gamma/<ws>o)
+   !! DCSE_NEMO: ghats does not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghats    !: non-local scalar mixing term (gamma/<ws>o)
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghats    !: non-local scalar mixing term (gamma/<ws>o)
+
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   wt0      !: surface temperature flux for non local flux
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ws0      !: surface salinity flux for non local flux
@@ -130,17 +133,35 @@
         
 #if defined key_c1d
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rig    !: gradient Richardson number
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rib    !: bulk Richardson number
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   buof   !: buoyancy forcing
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mols   !: moning-Obukhov length scale 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ekdp   !: Ekman depth
+!! DCSE_NEMO: these arrays do not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rig    !: gradient Richardson number
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rib    !: bulk Richardson number
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   buof   !: buoyancy forcing
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mols   !: moning-Obukhov length scale 
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ekdp   !: Ekman depth
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rig    !: gradient Richardson number
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rib    !: bulk Richardson number
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   buof   !: buoyancy forcing
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   mols   !: moning-Obukhov length scale 
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ekdp   !: Ekman depth
 #endif
 
    INTEGER  ::   jip = 62 , jjp = 111
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+!FTRANS ghats :I :I :z
+!FTRANS etmean eumean evmean :I :I :z
+#if defined key_c1d
+!FTRANS rig rib buof mols :I :I :z
+#endif
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
-#  include  "zdfddm_substitute.h90"
+#  include "zdfddm_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
@@ -210,7 +231,9 @@
       USE oce     , zdiffut => ta   ! temp. array for diffusivities use sa as workspace
       USE oce     , zdiffus => sa   ! temp. array for diffusivities use sa as workspace
+!FTRANS zviscos zdiffut zdiffus :I :I :z
 #else
       USE oce     , zviscos => ua   ! temp. array for viscosities use ua as workspace
       USE oce     , zdiffut => ta   ! temp. array for diffusivities use sa as workspace
+!FTRANS zviscos zdiffut :I :I :z
 #endif
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released, wrk_in_use_xz, wrk_not_released_xz
@@ -228,6 +251,10 @@
       USE wrk_nemo, ONLY: zblcm => wrk_xz_1, &   ! Boundary layer 
                           zblct => wrk_xz_2      !  diffusivities/viscosities
+
+      !! DCSE_NEMO: check that wrk_xz_* arrays are being used consistently
+!FTRANS zblcm zblct :I :z
 #if defined key_zdfddm
       USE wrk_nemo, ONLY: zblcs => wrk_xz_3
+!FTRANS zblcs :I :z
 #endif
       !!
@@ -323,7 +350,13 @@
       ! I. Interior diffusivity and viscosity at w points ( T interfaces)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1 
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1 
+#endif
                ! Mixing due to internal waves breaking
                ! -------------------------------------
@@ -523,4 +556,6 @@
          ! Compute the pipe
          ! ---------------------
+
+         !! DCSE_NEMO: is it safe to change the order of these loops?
          DO jk = 2, jpkm1
             DO ji = fs_2, fs_jpim1
@@ -1135,7 +1170,13 @@
          CASE ( 0 )             ! no viscosity and diffusivity smoothing
 
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 2, jpkm1
+#else
             DO jk = 2, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1
+#endif
                      avmu(ji,jj,jk) = ( zviscos(ji,jj,jk) + zviscos(ji+1,jj,jk) ) &
                         &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji + 1,jj,jk) ) * umask(ji,jj,jk)
@@ -1158,7 +1199,13 @@
             !           ( 1/2  1  1/2 )              ( 1/2  1/2 )
   
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 2, jpkm1
+#else
             DO jk = 2, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1
+#endif
 
                      avmu(ji,jj,jk) = (      zviscos(ji  ,jj  ,jk) + zviscos(ji+1,jj  ,jk)   &
@@ -1188,4 +1235,30 @@
          END SELECT
 
+#if defined key_z_first
+         !
+         !  Minimum value on the eddy diffusivity
+         ! ----------------------------------------
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+                  avt(ji,jj,jk) = MAX( avt(ji,jj,jk), avtb(jk) ) * tmask(ji,jj,jk)
+#if defined key_zdfddm  
+                  avs(ji,jj,jk) = MAX( avs(ji,jj,jk), avtb(jk) ) * tmask(ji,jj,jk)
+#endif
+               END DO
+            END DO
+         END DO
+         !
+         ! Minimum value on the eddy viscosity
+         ! ----------------------------------------
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+                  avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk), avmb(jk) ) * umask(ji,jj,jk)
+                  avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk), avmb(jk) ) * vmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, jpkm1                       ! vertical slab
             !
@@ -1212,4 +1285,5 @@
             !
          END DO
+#endif
 
          ! Lateral boundary conditions on avt  (sign unchanged)
@@ -1241,4 +1315,15 @@
    END SUBROUTINE zdf_kpp
 
+   !! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+!FTRANS ghats :I :I :z
+!FTRANS etmean eumean evmean :I :I :z
+#if defined key_c1d
+!FTRANS rig rib buof mols :I :I :z
+#endif
 
    SUBROUTINE tra_kpp( kt )
@@ -1252,4 +1337,5 @@
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!----------------------------------------------------------------------
+!FTRANS ztrdt ztrds :I :I :z
       INTEGER, INTENT(in) :: kt
       INTEGER :: ji, jj, jk
@@ -1267,7 +1353,13 @@
 
       ! add non-local temperature and salinity flux ( in convective case only)
+#if defined key_z_first
+      DO jj = 2, jpjm1 
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1 
             DO ji = fs_2, fs_jpim1
+#endif
                tsa(ji,jj,jk,jp_tem) =  tsa(ji,jj,jk,jp_tem)                      &
                   &                 - (  ghats(ji,jj,jk  ) * avt  (ji,jj,jk  )   & 
@@ -1298,4 +1390,17 @@
 
 #if defined key_top
+
+   !! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+!FTRANS ghats :I :I :z
+!FTRANS etmean eumean evmean :I :I :z
+#if defined key_c1d
+!FTRANS rig rib buof mols :I :I :z
+#endif
+
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
@@ -1322,4 +1427,5 @@
       REAL(wp) ::   ztra, zflx
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
+!FTRANS ztrtrd :I :I :z
       !!----------------------------------------------------------------------
 
@@ -1336,7 +1442,13 @@
          IF( l_trdtrc )  ztrtrd(:,:,:)  = tra(:,:,:,jn)
          ! add non-local on passive tracer flux ( in convective case only)
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1
+#endif
                   ! Surface tracer flux for non-local term 
                   zflx = - ( emps(ji,jj) * tra(ji,jj,1,jn) * rcs ) * tmask(ji,jj,1)
@@ -1372,4 +1484,17 @@
 #endif
 
+   !! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+!FTRANS ghats :I :I :z
+!FTRANS etmean eumean evmean :I :I :z
+#if defined key_c1d
+!FTRANS rig rib buof mols :I :I :z
+#endif
+
+
    SUBROUTINE zdf_kpp_init
       !!----------------------------------------------------------------------
@@ -1477,7 +1602,13 @@
          evmean(:,:,:) = 0.e0
          
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
-               DO ji = 2, jpim1   ! vector opt.
+               DO ji = 2, jpim1
+#endif
                   etmean(ji,jj,jk) = tmask(ji,jj,jk)                     &
                   &  / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
@@ -1503,7 +1634,13 @@
          evmean(:,:,:) = 0.e0
          
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   etmean(ji,jj,jk) = tmask(ji, jj,jk)                           &
                      & / MAX( 1., 2.* tmask(ji,jj,jk)                           &
@@ -1534,4 +1671,13 @@
       ! Initialization of vertical eddy coef. to the background value
       ! -------------------------------------------------------------
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            avt (ji,jj,:) = avtb(:) * tmask(ji,jj,:)
+            avmu(ji,jj,:) = avmb(:) * umask(ji,jj,:)
+            avmv(ji,jj,:) = avmb(:) * vmask(ji,jj,:)
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
@@ -1539,4 +1685,5 @@
          avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
       END DO
+#endif
 
       ! zero the surface flux for non local term and kpp mixed layer depth
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 3211)
@@ -26,4 +26,9 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlp    !: mixed layer depth  (rho=rho0+zdcrit) [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlpt   !: mixed layer depth at t-points        [m]
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
 
    !! * Substitutions
@@ -90,7 +95,13 @@
       nmln(:,:) = mbkt(:,:) + 1        ! Initialization to the number of w ocean point
       imld(:,:) = mbkt(:,:) + 1
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = jpkm1, nlb10, -1   ! from the bottom to nlb10
+#else
       DO jk = jpkm1, nlb10, -1         ! from the bottom to nlb10
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                IF( rhop(ji,jj,jk) > rhop(ji,jj,nla10) + zrho_c )   nmln(ji,jj) = jk      ! Mixed layer
                IF( avt (ji,jj,jk) < zavt_c                     )   imld(ji,jj) = jk      ! Turbocline 
@@ -103,6 +114,11 @@
             iiki = imld(ji,jj)
             iikn = nmln(ji,jj)
+#if defined key_z_first
+            hmld (ji,jj) = fsdepw(ji,jj,iiki  ) * tmask_1(ji,jj)    ! Turbocline depth 
+            hmlp (ji,jj) = fsdepw(ji,jj,iikn  ) * tmask_1(ji,jj)    ! Mixed layer depth
+#else
             hmld (ji,jj) = fsdepw(ji,jj,iiki  ) * tmask(ji,jj,1)    ! Turbocline depth 
             hmlp (ji,jj) = fsdepw(ji,jj,iikn  ) * tmask(ji,jj,1)    ! Mixed layer depth
+#endif
             hmlpt(ji,jj) = fsdept(ji,jj,iikn-1)                     ! depth of the last T-point inside the mixed layer
          END DO
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 3211)
@@ -41,4 +41,10 @@
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tmric   !: coef. for the horizontal mean at t-point
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS tmric :I :I :z
 
    !! * Substitutions
@@ -101,4 +107,7 @@
          CALL ctl_stop('zdf_ric : requested workspace array unavailable')   ;   RETURN
       ENDIF
+
+      !! DCSE_NEMO: To optimise this loop for z_first indexing, make zwx 3-dimensional
+
       !                                                ! ===============
       DO jk = 2, jpkm1                                 ! Horizontal slab
@@ -187,7 +196,13 @@
       IF( zdf_ric_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_ric_init : unable to allocate arrays' )
       !
+#if defined key_z_first
+      DO jj = 2, jpj 
+         DO ji = 2, jpi
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk                 ! weighting mean array tmric for 4 T-points
          DO jj = 2, jpj              ! which accounts for coastal boundary conditions            
             DO ji = 2, jpi
+#endif
                tmric(ji,jj,jk) =  tmask(ji,jj,jk)                                  &
                   &            / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
@@ -198,4 +213,15 @@
       tmric(:,1,:) = 0._wp
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk           ! Initialization of vertical eddy coef. to the background value
+               avt (ji,jj,jk) = avtb(jk) * tmask(ji,jj,jk)
+               avmu(ji,jj,jk) = avmb(jk) * umask(ji,jj,jk)
+               avmv(ji,jj,jk) = avmb(jk) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 1, jpk                 ! Initialization of vertical eddy coef. to the background value
          avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
@@ -203,4 +229,5 @@
          avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
       END DO
+#endif
       !
    END SUBROUTINE zdf_ric_init
